local _G = _G
local L = PetSelector.L

--respond to LibGroupTalent events
function PetSelector:SetPet()

	local pet
	
	if self.incombat then return end
	
	self:CheckBuffs()
	pet = self:SelectPet()
	
	if pet then
	
		self.button.icon:SetTexture(pet.icon)

	end
	
end

--watch events
function PetSelector:eventHandler(this, event, arg1, ...)
	
	local activepet
	
	if event == "ADDON_LOADED" and arg1 == "PetSelector" then

		if PetSelectorDB == nil then

			PetSelectorDB = {}
			
		end
	
		self.GT.RegisterCallback(self, "LibGroupTalents_Update", "SetPet")
		
	elseif event == "PLAYER_LOGIN" then
		
		--configure options
		self.defaults = {
			profile = {
			showinparty = true,
			locked = false,
			stabled = true,
			x = (UIParent:GetWidth() - 32) / 2,
			y = (UIParent:GetHeight() - 32) / 2,
			bx = ((UIParent:GetWidth() - 150) / 2) + 32,
			by = (UIParent:GetHeight() - 300) /2,
			px = ((UIParent:GetWidth() - 150) / 2),
			py = (UIParent:GetHeight() - 300) /2,
			scale = UIParent:GetScale(),
			bfskin = "Blizzard",
			bfgloss = 0,
			bfbackdrop = false,
			bfcolours = {},
			},
		}

		self.frame:RegisterEvent("PLAYER_LEVEL_UP")
		self.frame:RegisterEvent("PLAYER_REGEN_ENABLED")
		self.frame:RegisterEvent("PLAYER_REGEN_DISABLED")
		self.frame:RegisterEvent("PARTY_MEMBERS_CHANGED")
		self.frame:RegisterEvent("PARTY_MEMBERS_CHANGED")
		self.frame:RegisterEvent("PARTY_MEMBER_DISABLED")
		self.frame:RegisterEvent("PARTY_MEMBER_ENABLED")
		self.frame:RegisterEvent("PET_STABLE_UPDATE")
		self.frame:RegisterEvent("UNIT_PET")
		self.frame:RegisterEvent("UNIT_LEVEL")
	
		self.faction = UnitFactionGroup("player")
		self.db = LibStub("AceDB-3.0"):New("PetSelectorVars", self.defaults, "profile")
		self:createPetSelectorOptions()	
		
		--create main frame
		self:CreatePetFrame()
		self:CreateBuffFrame(false)
		self:CreateBuffFrame(true)
		self:DisplayFrames()
		
	elseif event == "PLAYER_LEVEL_UP" then
	
		--force a rescan if the player levels up
		self.PlayerLevel = arg1
		self:SetPet()
		
	elseif event == "PET_STABLE_UPDATE" then
	
		self:SetPet()
		
	elseif event == "UNIT_PET" then

		if arg1 == "player" then

			if not self.random then
			
				self:SetPet()
				
			end
		
		else
		
			self:SetPet()
			
		end
		
	elseif (event == "UNIT_LEVEL") and (arg1 == "pet") then
	
		self:SetPet()
	
	elseif event == "PARTY_MEMBERS_CHANGED" or event == "PARTY_MEMBER_DISABLED" or event == "PARTY_MEMBER_ENABLED" then
	
		if GetNumPartyMembers() > 0 then
		
			self.inparty = true
			
		else
		
			self.inparty = nil
			
		end
		
		self:DisplayFrames()
		self:SetPet()
		
	elseif event == "PLAYER_REGEN_ENABLED" then
	
		self.incombat = nil
		
	elseif event == "PLAYER_REGEN_DISABLED" then
	
		self.incombat = true

	end

end